"""
Install method

$Id: Install.py 11 2009-08-12 18:12:39Z alexandre.garel $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.SmartCsvExporter.config import PROJECT_NAME
from Products.SmartCsvExporter.tools.SmartCsvExporterTool import SmartCsvExporterTool
from Products.SmartCsvExporter import security


def install(self):
    """
    Install this product
    """
    out = StringIO()
    print >> out, 'Installing %s' % PROJECT_NAME

    ## Add tool
    portal = getToolByName(self, 'portal_url').getPortalObject()
    if getToolByName(portal, SmartCsvExporterTool.id, None) is None:
        t = SmartCsvExporterTool()
        portal._setObject(SmartCsvExporterTool.id, t)

    ## Create action
    at = getToolByName(self, 'portal_actions') 
    try:
        at.addAction('export-csv',
                     name='Export as CSV',
                     action='string:${object_url}/portal_smart_csv_exporter/export_as_csv',
                     condition="python: object.portal_type=='Topic'",
                     permission=security.EXPORT_CSV_PERMISSION,
                     category='object')
    except:
        pass
    return out.getvalue()

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()

def uninstall(self):
    """uninstall"""
    out = StringIO()
    print >> out, 'Uninstalling %s' % PROJECT_NAME
    # remove action
    at = getToolByName(self, 'portal_actions') 
    try:
        to_remove = [i for  i, x in enumerate(at.listActions()) 
                     if x.id == 'export-csv']
        at.deleteActions(to_remove)
    except:
        pass
    print >> out, "Successfully uninstalled %s." % PROJECT_NAME
    return out.getvalue()

